import numpy as np
import pandas as pd
from sklearn import metrics
from sklearn.datasets import make_classification
from sklearn.linear_model import LogisticRegression, Ridge
from sklearn.naive_bayes import GaussianNB
from sklearn.neighbors import KNeighborsClassifier
from sklearn.ensemble import (RandomTreesEmbedding,RandomForestClassifier,GradientBoostingClassifier)
from sklearn.multiclass import OneVsRestClassifier
from sklearn.neighbors import KNeighborsClassifier
from sklearn.preprocessing import OneHotEncoder
from sklearn.model_selection import train_test_split
from sklearn.metrics import roc_curve,roc_auc_score,accuracy_score,auc
from sklearn.metrics import accuracy_score
from sklearn.metrics import precision_score
from sklearn.metrics import recall_score
from sklearn.metrics import f1_score
import matplotlib.pyplot as plt
from sklearn.neural_network import MLPClassifier

accuracy1=[]
precision1=[]
recall_score1=[]
f1_score1=[]
DictOfPvalue = {}
Dict = {}
n_estimator1=[]
depth1=[]
n_neighbors1=[]

# crypt = pd.read_csv(r"E:\eee\CryptoSystemIdentifier\classification2\data\10features\diffkey\NIST_512kb_keyDiff_5.csv")
crypt = pd.read_csv(r"..\Data\Multi-classification identification on cryptographic algorithms\512KB.csv")
data = crypt.iloc[:,:-1].values   #选择直到数据的倒数第二列
label = crypt.iloc[:, 10].values  #选择数据的第10列作为label
X_train,X_test,Y_train,Y_test = train_test_split(data,label,test_size=0.2,random_state=0)#sklearn包的model_selection模块中提供的随机划分训练集和测试集的函数
X_train_tree,X_train_knn,Y_train_tree,Y_train_knn = train_test_split(X_train,Y_train,test_size=0.5)
for n_estimator in range(80,90):#森林模型中有多少颗树[80, 100, 150, 200, 250]
    for depth in range(1,10):#树的深度[1, 2, 3, 5]
        for n_neighbors in range(5,9):#[300, 400, 500]
            # 随机森林
            RF = RandomForestClassifier(n_estimators=n_estimator, max_depth=depth,oob_score=True)
            OHE = OneHotEncoder()
            KNNRF = KNeighborsClassifier(n_neighbors=n_neighbors)#LogisticRegression(max_iter=maxiter)
            #KNNRF=MLPClassifier(solver='lbfgs', alpha=1e-5, hidden_layer_sizes=(8, 21), random_state=1,max_iter=5000)  # 8,21最好
            RF.fit(X_train_tree, Y_train_tree)#用训练数据集来构造森林
            #RF.apply(X_train_tree)#将森林中的树应用于X，返回叶子索引
            OHE.fit(RF.apply(X_train_tree))#经过独热编码后，特征变成了稀疏的了。这有两个好处，一是解决了分类器不好处理属性数据的问题，二是在一定程度上也起到了扩充特征的作用
            #KNNRF = OneVsRestClassifier(KNNRF)  # 进行多分类转换OVR
            KNNRF.fit(OHE.transform(RF.apply(X_train_knn)), Y_train_knn)#onehot的transform方法输出矩阵为二维稀疏矩阵，使用随机森林构造的特征来训练KNN
            #Y_pred_rf_knn_auc = KNNRF.predict_proba(OHE.transform(RF.apply(X_test)))[:, 1]#预测X的类概率
            Y_pred_rf_knn = KNNRF.predict(OHE.transform(RF.apply(X_test)))#预测X的类
            # print("Accuracy: ", accuracy_score(Y_test, Y_pred_rf_knn))#找出测试值与预测值不同总数除以测试值总数
            # print("precision: ", precision_score(Y_test, Y_pred_rf_knn, average='weighted'))  # 多分类加参数
            # print("recall_score: ", recall_score(Y_test, Y_pred_rf_knn, average='weighted'))
            # print("f1_score: ", f1_score(Y_test, Y_pred_rf_knn, average='micro'))
            #print(n_estimator, depth, maxiter)
            Accuracy0 = accuracy_score(Y_test, Y_pred_rf_knn)
            precision0 = precision_score(Y_test, Y_pred_rf_knn, average='weighted')
            recall_score0 = recall_score(Y_test, Y_pred_rf_knn, average='weighted')
            f1_score0 = f1_score(Y_test, Y_pred_rf_knn, average='micro')
            print("Accuracy: ", Accuracy0)
            print("precision: ", precision0)
            print("recall_score: ", recall_score0)
            print("f1_score: ", f1_score0)
            print("------------")
            accuracy1.append(round(Accuracy0, 3))
            precision1.append(round(precision0, 3))
            recall_score1.append(round(recall_score0, 3))
            f1_score1.append(round(f1_score0, 3))
            n_estimator1.append(n_estimator)
            depth1.append(depth)
            n_neighbors1.append(n_neighbors)
DictOfPvalue={'accuracy1':accuracy1,
              'precision1':precision1,
              'recall_score1':recall_score1,
              'f1_score1':f1_score1,
              'n_estimator1':n_estimator1,
              'depth1':depth1,
              'n_neighbors1':n_neighbors1}
